/**
 *
 */
package de.intevation.gnv.action.sessionmodel;

import java.util.Collection;
import java.util.Iterator;

import de.intevation.gnv.artifactdatabase.objects.ArtifactObject;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class DefaultSessionModel implements SessionModel{


    private Collection<ArtifactObject> artifactFactories = null;
    
    private ArtifactObject selectedArtifactFactory = null;
    
    private ArtifactObject currentArtifact  =null;
   

    /**
     * Constructor
     */
    public DefaultSessionModel() {
        super();
    }

    /**
     * @see de.intevation.gnv.action.sessionmodel.SessionModel#selectArtifactFactory(java.lang.String)
     */
    public void selectArtifactFactory(String artiFactFactoryId) {
        Collection<ArtifactObject> artifactObjects = this.getArtifactFactories();
        if (artifactObjects != null){
            Iterator<ArtifactObject> unselect = artifactObjects.iterator();
            this.selectedArtifactFactory = null;
            while (unselect.hasNext()){
                unselect.next().setSelected(false);
            }
            Iterator<ArtifactObject> it = artifactObjects.iterator();
            while (it.hasNext()){
                 ArtifactObject obj = it.next();
                 if(obj.getId().equals(artiFactFactoryId)){
                     obj.setSelected(true);
                     this.selectedArtifactFactory = obj;
                     break;
                 }
            }
        }
    }

    /**
     * @see de.intevation.gnv.action.sessionmodel.SessionModel#setArtifacteFactories(java.util.Collection)
     */
    public void setArtifacteFactories(
            Collection<ArtifactObject> artifactFactories) {
        this.artifactFactories = artifactFactories;
    }
    
    /**
     * @see de.intevation.gnv.action.sessionmodel.SessionModel#getAttributeFactories()
     */
    public Collection<ArtifactObject> getArtifactFactories() {
        return this.artifactFactories;
    }

    /**
     * @see de.intevation.gnv.action.sessionmodel.SessionModel#getSelectedArtifactFactory()
     */
    public ArtifactObject getSelectedArtifactFactory() {
        return this.selectedArtifactFactory;
    }

    /**
     * @see de.intevation.gnv.action.sessionmodel.SessionModel#getCurrentArtifact()
     */
    public ArtifactObject getCurrentArtifact() {
        return this.currentArtifact;
    }

    /**
     * @see de.intevation.gnv.action.sessionmodel.SessionModel#setCurrentArtifact(de.intevation.gnv.artifactdatabase.objects.ArtifactObject)
     */
    public void setCurrentArtifact(ArtifactObject artifact) {
        this.currentArtifact = artifact;
    }
    

}
